var FdFile = {
  getImagesDirectory : function() {
    var file = Components.classes["@mozilla.org/file/directory_service;1"]
               .getService(Components.interfaces.nsIProperties)
               .get("ProfD", Components.interfaces.nsIFile);
    file.append("fastdial");
    if (!file.exists()) file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
    return file;
  },

  getImageName : function(id) {
    return id + ".png";
  }, 

  deleteImage : function(id) {
    var file = FdFile.getImagesDirectory();
    file.append(FdFile.getImageName(id));
    try { file.remove(false); } catch(e) { alert("Error: Can't remove image: " + FdFile.getImageName(id)); }
  },

  getImageURL : function(id) {
    return "chrome://fastdial-images/content/" + FdFile.getImageName(id) + "?" + new Date().getTime();
  },

  saveCanvas : function(canvas, id, onFinish) {
    var file = FdFile.getImagesDirectory();
    file.append(FdFile.getImageName(id));

    var io = Components.classes["@mozilla.org/network/io-service;1"]
                       .getService(Components.interfaces.nsIIOService);
    var source = io.newURI(canvas.toDataURL("image/png"), "UTF-8", null);
      
    var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
                            .createInstance(Components.interfaces.nsIWebBrowserPersist);

    persist.persistFlags = persist.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
    persist.persistFlags |= persist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
    
    persist.saveURI(source, null, null, null, null, file);

    function wait() {
      if (persist.currentState == persist.PERSIST_STATE_FINISHED) return onFinish();
      else setTimeout(wait, 100);
    }
    if (onFinish) wait();
  },

  createInputStream : function(file) {
    var stream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                 .createInstance(Components.interfaces.nsIFileInputStream);
    stream.init(file, -1, 0, 0);
    var scriptable = Components.classes["@mozilla.org/scriptableinputstream;1"]
                     .createInstance(Components.interfaces.nsIScriptableInputStream);
    scriptable.init(stream); 
    return { stream : stream,
             scriptable : scriptable,
             readFully : function() {
               return this.scriptable.read(this.scriptable.available());
             },
             close : function() {
               this.scriptable.close();
               this.stream.close();
             }
           };
  },

  readFile : function(file) {
    if (file instanceof Components.interfaces.nsIFile) nsiFile = file;
    else {
      var nsiFile = Components.classes["@mozilla.org/file/local;1"]
                    .getService(Components.interfaces.nsILocalFile);
      nsiFile.initWithPath(file);
    }
    var inn = FdFile.createInputStream(nsiFile);
    try {
      return inn.readFully();
    }
    finally {
      inn.close();
    }
  },

  getExtensionDirectory : function() {
    var file = Components.classes["@mozilla.org/file/directory_service;1"]
               .getService(Components.interfaces.nsIProperties)
               .get("ProfD", Components.interfaces.nsIFile);
    file.append("extensions");
    file.append("fastdial@telega.phpnet.us");
    file.append("chrome");
    file.append("content");
    return file;
  }
}
