var FdPrefs = {
  prefs : Components.classes["@mozilla.org/preferences-service;1"]
          .getService(Components.interfaces.nsIPrefService)
          .getBranch("extensions.fastdial."),

  getURL : function(id) {
    try {
      return this.prefs.getCharPref(id + ".url");
    } catch(e) {
      return null;
    }
  },

  getTitle : function(id) {
    try {
      return decodeURIComponent(this.prefs.getCharPref(id + ".title"));
    } catch(e) {
      return null;
    }
  },

  setURL : function(id, url) {
    this.prefs.setCharPref(id + ".url", url);
  },

  setTitle : function(id, title) {
    this.prefs.setCharPref(id + ".title", encodeURIComponent(title));
  },

  clear : function(id) {
    try {
      this.prefs.clearUserPref(id + ".url");
    } catch(e) {}
    try {
      this.prefs.clearUserPref(id + ".title");
    } catch(e) {}
  },

  saveWindowSize : function() {
    var wnd = gBrowser.selectedBrowser.contentWindow;
    this.prefs.setCharPref("windowSize", "({ width: " + wnd.innerWidth + ", " +
                                            "height: " + wnd.innerHeight + " })");
  },

  getWindowSize : function() {
    try {
      return eval(this.prefs.getCharPref("windowSize"));
    } catch(e) {
      return null;
    }
  }
}
